Index: blog/locallib.php
=========================================================
--- blog/locallib.php	(revision 1.7)
+++ blog/locallib.php	Wed Oct 28 16:42:23 WST 2009
@@ -999,8 +1034,8 @@
 
                     $context = get_context_instance(CONTEXT_MODULE, $this->id);
                     $this->tables['ba'] = 'blog_association';
-                    $this->tables['b']  = 'blog_entries';
-                    $this->conditions = array('b.id = ba.blogid', 'ba.contextid = ?');
+                    $this->tables['p']  = 'post';
+                    $this->conditions = array('p.id = ba.blogid', 'ba.contextid = ?');
                     $this->params = array($context->id);
                 }
                 break;
@@ -1023,7 +1058,7 @@
      */
     public function __construct($id=null, $type='user') {
         global $CFG, $DB;
-        $this->available_types = array('user' => get_string('user'), 'group' => get_string('group'));
+        $this->availabletypes = array('user' => get_string('user'), 'group' => get_string('group'));
 
         if (empty($id)) {
             $this->id = $USER->id;
@@ -1042,18 +1077,18 @@
             $this->overrides = array('course', 'site');
 
             $this->tables['gm'] = 'groups_members';
-            $this->conditions[] = 'b.userid = gm.userid';
+            $this->conditions[] = 'p.userid = gm.userid';
             $this->conditions[] = 'gm.groupid = ?';
             $this->params[]     = $this->id;
 
             if (!empty($CFG->useblogassociations)) {  // only show blog entries associated with this course
-                $course_context     = get_context_instance(CONTEXT_COURSE, $DB->get_field('groups', 'courseid', array('id' => $this->id)));
+                $coursecontext     = get_context_instance(CONTEXT_COURSE, $DB->get_field('groups', 'courseid', array('id' => $this->id)));
                 $this->tables['ba'] = 'blog_association';
                 $this->conditions[] = 'gm.groupid = ?';
                 $this->conditions[] = 'ba.contextid = ?';
-                $this->conditions[] = 'ba.blogid = b.id';
+                $this->conditions[] = 'ba.blogid = p.id';
                 $this->params[]     = $this->id;
-                $this->params[]     = $course_context->id;
+                $this->params[]     = $coursecontext->id;
             }
         }
 
@@ -1064,7 +1099,7 @@
  * This filter defines a tag by which blog entries should be searched.
  */
 class blog_filter_tag extends blog_filter {
-    public $tables = array('t' => 'tag', 'ti' => 'tag_instance', 'b' => 'blog_entries');
+    public $tables = array('t' => 'tag', 'ti' => 'tag_instance', 'p' => 'post');
 
     /**
      * Constructor
@@ -1076,8 +1111,8 @@
         $this->id = $id;
 
         $this->conditions = array('ti.tagid = t.id',
-                                  "ti.itemtype = 'blog_entries'",
-                                  'ti.itemid = b.id',
+                                  "ti.itemtype = 'post'",
+                                  'ti.itemid = p.id',
                                   't.id = ?');
         $this->params = array($this->id);
     }
@@ -1097,15 +1132,29 @@
 }
 
 /**
+ * This filter restricts the results to a time interval in seconds up to mktime()
+ */
+class blog_filter_since extends blog_filter {
+    public function __construct($interval) {
+        $this->conditions[] = 'p.lastmodified >= ? AND p.lastmodified <= ?';
+        $this->params[] = mktime() - $interval;
+        $this->params[] = mktime();
+    }
+}
+
+/**
  * Filter used to perform full-text search on an entry's subject, summary and content
  */
 class blog_filter_search extends blog_filter {
 
-    public function __construct($search_term) {
+    public function __construct($searchterm) {
         global $DB;
         $ilike = $DB->sql_ilike();
-        $this->conditions = array("(b.summary $ilike '%$search_term%' OR
-                                    b.content $ilike '%$search_term%' OR
-                                    b.subject $ilike '%$search_term%')");
+        $this->conditions = array("(p.summary $ilike ? OR
+                                    p.content $ilike ? OR
+                                    p.subject $ilike ?)");
+        $this->params[] = "%$searchterm%";
+        $this->params[] = "%$searchterm%";
+        $this->params[] = "%$searchterm%";
     }
 }
Index: blog/rsslib.php
=========================================================
--- blog/rsslib.php	(revision 1.20)
+++ blog/rsslib.php	Fri Oct 23 14:14:18 WST 2009
@@ -1,166 +1,165 @@
 <?php
 
-    require_once($CFG->dirroot.'/lib/rsslib.php');
-    require_once($CFG->dirroot .'/blog/lib.php');
-
+require_once($CFG->dirroot.'/lib/rsslib.php');
+require_once($CFG->dirroot .'/blog/lib.php');
 
-    // This function returns the icon (from theme) with the link to rss/file.php
-    // needs some hacking to rss/file.php
-    function blog_rss_print_link($filtertype, $filterselect, $tagid=0, $tooltiptext='') {
+// This function returns the icon (from theme) with the link to rss/file.php
+// needs some hacking to rss/file.php
+function blog_rss_print_link($filtertype, $filterselect, $tagid=0, $tooltiptext='') {
 
-        global $CFG, $USER, $OUTPUT;
+    global $CFG, $USER, $OUTPUT;
 
-        if (empty($USER->id)) {
-            $userid = 1;
-        } else {
-            $userid = $USER->id;
-        }
+    if (empty($USER->id)) {
+        $userid = 1;
+    } else {
+        $userid = $USER->id;
+    }
 
-        switch ($filtertype) {
-            case 'site':
-                $path = SITEID.'/'.$userid.'/blog/site/'.SITEID;
-            break;
-            case 'course':
-                $path = $filterselect.'/'.$userid.'/blog/course/'.$filterselect;
-            break;
-            case 'group':
-                $path = SITEID.'/'.$userid.'/blog/group/'.$filterselect;
-            break;
-            case 'user':
-                $path = SITEID.'/'.$userid.'/blog/user/'.$filterselect;
-            break;
-        }
+    switch ($filtertype) {
+        case 'site':
+            $path = SITEID.'/'.$userid.'/blog/site/'.SITEID;
+        break;
+        case 'course':
+            $path = $filterselect.'/'.$userid.'/blog/course/'.$filterselect;
+        break;
+        case 'group':
+            $path = SITEID.'/'.$userid.'/blog/group/'.$filterselect;
+        break;
+        case 'user':
+            $path = SITEID.'/'.$userid.'/blog/user/'.$filterselect;
+        break;
+    }
 
-        if ($tagid) {
-            $path .= '/'.$tagid;
-        }
+    if ($tagid) {
+        $path .= '/'.$tagid;
+    }
 
-        $path .= '/rss.xml';
-        $rsspix = $OUTPUT->old_icon_url('i/rss');
+    $path .= '/rss.xml';
+    $rsspix = $OUTPUT->old_icon_url('i/rss');
 
-        require_once($CFG->libdir.'/filelib.php');
-        $path = get_file_url($path, null, 'rssfile');
-        print '<div class="mdl-right"><a href="'. $path .'"><img src="'. $rsspix .'" title="'. strip_tags($tooltiptext) .'" alt="'.get_string('rss').'" /></a></div>';
+    require_once($CFG->libdir.'/filelib.php');
+    $path = get_file_url($path, null, 'rssfile');
+    print '<div class="mdl-right"><a href="'. $path .'"><img src="'. $rsspix .'" title="'. strip_tags($tooltiptext) .'" alt="'.get_string('rss').'" /></a></div>';
 
-    }
+}
 
 
-    // Generate any blog RSS feed via one function (called by ../rss/file.php)
-    function blog_generate_rss_feed($type, $id, $tagid=0) {
+// Generate any blog RSS feed via one function (called by ../rss/file.php)
+function blog_generate_rss_feed($type, $id, $tagid=0) {
-        global $CFG, $SITE, $DB;
+    global $CFG, $SITE, $DB;
 
-        if (empty($CFG->enablerssfeeds)) {
-            debugging('Sorry, RSS feeds are disabled on this site');
-            return '';
-        }
+    if (empty($CFG->enablerssfeeds)) {
+        debugging('Sorry, RSS feeds are disabled on this site');
+        return '';
+    }
 
-        $filename = blog_rss_file_name($type, $id, $tagid);
+    $filename = blog_rss_file_name($type, $id, $tagid);
 
-        if (file_exists($filename)) {
-            if (filemtime($filename) + 3600 > time()) {
-                return $filename;   /// It's already done so we return cached version
-            }
-        }
+    if (file_exists($filename)) {
+        if (filemtime($filename) + 3600 > time()) {
+            return $filename;   /// It's already done so we return cached version
+        }
+    }
 
-    /// Get all the entries from the database
+/// Get all the entries from the database
 
-        $blogentries = blog_fetch_entries('', 20, '', $type, $id, $tagid);
+    $blogentries = blog_fetch_entries('', 20, '', $type, $id, $tagid);
 
-    /// Now generate an array of RSS items
+/// Now generate an array of RSS items
-        if ($blogentries) {
-            $items = array();
-            foreach ($blogentries as $blog_entry) {
-                $item = NULL;
-                $item->author = fullname($DB->get_record('user', array('id'=>$blog_entry->userid))); // TODO: this is slow
-                $item->title = $blog_entry->subject;
-                $item->pubdate = $blog_entry->lastmodified;
-                $item->link = $CFG->wwwroot.'/blog/index.php?entryid='.$blog_entry->id;
-                $item->description = format_text($blog_entry->summary, $blog_entry->format);
+    if ($blogentries) {
+        $items = array();
+        foreach ($blogentries as $blog_entry) {
+            $item = NULL;
+            $item->author = fullname($DB->get_record('user', array('id'=>$blog_entry->userid))); // TODO: this is slow
+            $item->title = $blog_entry->subject;
+            $item->pubdate = $blog_entry->lastmodified;
+            $item->link = $CFG->wwwroot.'/blog/index.php?entryid='.$blog_entry->id;
+            $item->description = format_text($blog_entry->summary, $blog_entry->format);
-                if ( !empty($CFG->usetags) && ($blogtags = tag_get_tags_array('blog_entries', $blog_entry->id)) ) {
+            if ( !empty($CFG->usetags) && ($blogtags = tag_get_tags_array('post', $blog_entry->id)) ) {
-                    if ($blogtags) {
-                        $item->tags = $blogtags;
-                    }
-                    $item->tagscheme = $CFG->wwwroot . '/tag';
-                }
-                $items[] = $item;
-            }
-            $articles = rss_add_items($items);   /// Change structure to XML
-        } else {
-            $articles = '';
-        }
+                if ($blogtags) {
+                    $item->tags = $blogtags;
+                }
+                $item->tagscheme = $CFG->wwwroot . '/tag';
+            }
+            $items[] = $item;
+        }
+        $articles = rss_add_items($items);   /// Change structure to XML
+    } else {
+        $articles = '';
+    }
 
-    /// Get header and footer information
+/// Get header and footer information
 
-        switch ($type) {
-            case 'user':
-                $info = fullname($DB->get_record('user', array('id'=>$id), 'firstname,lastname'));
-                break;
-            case 'course':
-                $info = $DB->get_field('course', 'fullname', array('id'=>$id));
-                break;
-            case 'site':
-                $info = $SITE->fullname;
-                break;
-            case 'group':
-                $group = groups_get_group($id, false);
-                $info = $group->name; //TODO: $DB->get_field('groups', 'name', array('id'=>$id))
-                break;
-            default:
-                $info = '';
-                break;
-        }
+    switch ($type) {
+        case 'user':
+            $info = fullname($DB->get_record('user', array('id'=>$id), 'firstname,lastname'));
+            break;
+        case 'course':
+            $info = $DB->get_field('course', 'fullname', array('id'=>$id));
+            break;
+        case 'site':
+            $info = $SITE->fullname;
+            break;
+        case 'group':
+            $group = groups_get_group($id, false);
+            $info = $group->name; //TODO: $DB->get_field('groups', 'name', array('id'=>$id))
+            break;
+        default:
+            $info = '';
+            break;
+    }
 
-        if ($tagid) {
-            $info .= ': '.$DB->get_field('tags', 'text', array('id'=>$tagid));
-        }
+    if ($tagid) {
+        $info .= ': '.$DB->get_field('tags', 'text', array('id'=>$tagid));
+    }
 
-        $header = rss_standard_header(get_string($type.'blog','blog', $info),
-                                      $CFG->wwwroot.'/blog/index.php',
-                                      get_string('intro','blog'));
+    $header = rss_standard_header(get_string($type.'blog','blog', $info),
+                                  $CFG->wwwroot.'/blog/index.php',
+                                  get_string('intro','blog'));
 
-        $footer = rss_standard_footer();
+    $footer = rss_standard_footer();
 
 
-    /// Save the XML contents to file.
+/// Save the XML contents to file.
 
-        $rssdata = $header.$articles.$footer;
+    $rssdata = $header.$articles.$footer;
 
-        if (blog_rss_save_file($type,$id,$tagid,$rssdata)) {
-            return $filename;
-        } else {
-            return false;   // Couldn't find it or make it
-        }
+    if (blog_rss_save_file($type,$id,$tagid,$rssdata)) {
+        return $filename;
+    } else {
+        return false;   // Couldn't find it or make it
+    }
-    }
+}
 
 
-    function blog_rss_file_name($type, $id, $tagid=0) {
+function blog_rss_file_name($type, $id, $tagid=0) {
-        global $CFG;
+    global $CFG;
 
-        if ($tagid) {
-            return "$CFG->dataroot/rss/blog/$type/$id/$tagid.xml";
-        } else {
-            return "$CFG->dataroot/rss/blog/$type/$id.xml";
-        }
+    if ($tagid) {
+        return "$CFG->dataroot/rss/blog/$type/$id/$tagid.xml";
+    } else {
+        return "$CFG->dataroot/rss/blog/$type/$id.xml";
+    }
-    }
+}
 
-    //This function saves to file the rss feed specified in the parameters
-    function blog_rss_save_file($type, $id, $tagid=0, $contents='') {
+//This function saves to file the rss feed specified in the parameters
+function blog_rss_save_file($type, $id, $tagid=0, $contents='') {
-        global $CFG;
+    global $CFG;
 
-        if (! $basedir = make_upload_directory("rss/blog/$type/$id")) {
-            return false;
-        }
+    if (! $basedir = make_upload_directory("rss/blog/$type/$id")) {
+        return false;
+    }
 
-        $file = blog_rss_file_name($type, $id, $tagid);
-        $rss_file = fopen($file, 'w');
-        if ($rss_file) {
-            $status = fwrite ($rss_file, $contents);
-            fclose($rss_file);
-        } else {
-            $status = false;
-        }
+    $file = blog_rss_file_name($type, $id, $tagid);
+    $rss_file = fopen($file, 'w');
+    if ($rss_file) {
+        $status = fwrite ($rss_file, $contents);
+        fclose($rss_file);
+    } else {
+        $status = false;
+    }
 
-        return $status;
+    return $status;
-    }
+}
 
 ?>
Index: blog/simpletest/testbloglib.php
=========================================================
--- blog/simpletest/testbloglib.php	(revision 1.2)
+++ blog/simpletest/testbloglib.php	Tue Oct 27 15:06:43 WST 2009
@@ -32,6 +32,7 @@
     public static $includecoverage = array('blog/locallib.php');
 
     public function test_overrides() {
+
         // Try all the filters at once: Only the entry filter is active
         $blog_listing = new blog_listing(array('site' => 1, 'course' => 1, 'module' => 1, 'group' => 1, 'user' => 1, 'tag' => 1, 'entry' => 1));
         $this->assertFalse(array_key_exists('site', $blog_listing->filters));
@@ -60,28 +61,6 @@
         $this->assertTrue(array_key_exists('user', $blog_listing->filters));
         $this->assertTrue(array_key_exists('tag', $blog_listing->filters));
 
-        // Now use the group and module together
-        $blog_listing = new blog_listing(array('module' => 1, 'group' => 1, 'tag' => 1));
-        $this->assertTrue(array_key_exists('group', $blog_listing->filters));
-        $this->assertTrue(array_key_exists('module', $blog_listing->filters));
-        $this->assertFalse(array_key_exists('user', $blog_listing->filters));
-        $this->assertTrue(array_key_exists('tag', $blog_listing->filters));
-
-        $blog_listing = new blog_listing(array('course' => 2));
-        $this->assertTrue(array_key_exists('course', $blog_listing->filters));
-
-        $blog_listing = new blog_listing(array('course' => 2, 'group' => 12));
-        $this->assertFalse(array_key_exists('course', $blog_listing->filters));
-        $this->assertTrue(array_key_exists('group', $blog_listing->filters));
-
-        $blog_listing = new blog_listing(array('site' => 2, 'group' => 12));
-        $this->assertFalse(array_key_exists('site', $blog_listing->filters));
-        $this->assertTrue(array_key_exists('group', $blog_listing->filters));
-
-        $blog_listing = new blog_listing(array('user' => 2, 'group' => 12));
-        $this->assertFalse(array_key_exists('group', $blog_listing->filters));
-        $this->assertTrue(array_key_exists('user', $blog_listing->filters));
-
     }
 
     /**
@@ -89,38 +68,6 @@
      */
     public function test_blog_get_headers_case_1() {
         global $CFG, $PAGE, $OUTPUT;
-        
-        $this->create_test_tables('post', 'tag', 'course', 'user', 'role', 'role_assignments', 'group', 'blog_associations', 
-                                  'course_modules', 'role_capabilities', 'tag_correlation', 'tag_instance');
-        
-        $contexts = $this->load_test_data('context',
-                array('contextlevel', 'instanceid', 'path', 'depth'), array(
-           1 => array(40, 666, '', 2),
-           2 => array(50, 666, '', 3),
-           3 => array(70, 666, '', 4),
-        ));
-
-        $this->load_test_data('course', 
-                              array('id', 'fullname', 'shortname', 'format'), 
-                              array(
-                                array(1, 'My Moodle Site', 'moodle', 'site'),
-                                array(2, 'Course 1', 'course1', 'weeks'),
-                                array(3, 'Course 2', 'course2', 'weeks')
-                                )
-                              );
-        $this->load_test_data('user',
-                              array('id', 'confirmed', 'username', 'firstname', 'lastname'),
-                              array( array(1, 1, 'joebloe', 'Joe', 'Bloe')));
-
-        $this->switch_to_test_db();
-        
-        $userrole = create_role(get_string('authenticateduser'), 'user', get_string('authenticateduserdescription'), 'moodle/legacy:user');
-        $student = $this->testdb->get_record('role', array('shortname' => 'student'));
-        
-        $ras = $this->load_test_data('role_assignments', array('userid', 'roleid', 'contextid'),
-                                     array(array(1, $student->id, $context[2]->id)));
-
-        // Case 1: A single blog entry
         $PAGE->url = new moodle_url($CFG->wwwroot . '/blog/index.php', array('entryid' => 1));
         $blog_headers = blog_get_headers();
 
Index: course/report/outline/index.php
=========================================================
--- course/report/outline/index.php	(revision 1.26)
+++ course/report/outline/index.php	Thu Oct 22 14:45:11 WST 2009
@@ -31,6 +31,7 @@
     $strlast           = get_string('lastaccess');
     $strreports        = get_string('reports');
     $strviews          = get_string('views');
+    $strrelatedblogentries = get_string('relatedblogentries', 'blog');
 
     $PAGE->set_title($course->shortname .': '. $stractivityreport);
     $PAGE->set_heading($course->fullname);
@@ -43,15 +44,21 @@
         print_error('logfilenotavailable');
     }
 
-    echo '<div class="loginfo">'.get_string('computedfromlogs', 'admin', userdate($logstart)).'</div>';
+    echo $OUTPUT->container(get_string('computedfromlogs', 'admin', userdate($logstart)), 'loginfo');
+
+    $outlinetable = new html_table();
+    $outlinetable->add_class('generaltable boxaligncenter');
+    $outlinetable->cellpadding = 5;
+    $outlinetable->id = 'outlinetable';
+    $outlinetable->head = array($stractivity, $strviews);
 
-    echo '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5"><tr>';
-    echo '<th class="header c0" scope="col">'.$stractivity.'</th>';
-    echo '<th class="header c1" scope="col">'.$strviews.'</th>';
+    if ($CFG->useblogassociations) {
+        $outlinetable->head[] = $strrelatedblogentries;
+    }
+
     if ($showlastaccess) {
-        echo '<th class="header c2" scope="col">'.$strlast.'</th>';
+        $outlinetable->head[] = $strlast;
     }
-    echo '</tr>';
 
     $modinfo = get_fast_modinfo($course);
 
@@ -63,7 +70,6 @@
           GROUP BY cm.id";
     $views = $DB->get_records_sql($sql, array($course->id));
 
-    $ri = 0;
     $prevsecctionnum = 0;
     foreach ($modinfo->sections as $sectionnum=>$section) {
         foreach ($section as $cmid) {
@@ -75,41 +81,81 @@
                 continue;
             }
             if ($prevsecctionnum != $sectionnum) {
-                echo '<tr class="r'.$ri++.' section"><td colspan="3"><h3>';
+                $sectionrow = new html_table_row();
+                $sectionrow->add_class('section');
+                $sectioncell = new html_table_cell();
+                $sectioncell->colspan = count($outlinetable->head);
+
+                $sectiontitle = '';
                 switch ($course->format) {
-                    case 'weeks': print_string('week'); break;
-                    case 'topics': print_string('topic'); break;
-                    default: print_string('section'); break;
+                    case 'weeks': $sectiontitle = get_string('week'); break;
+                    case 'topics': $sectiontitle = get_string('topic'); break;
+                    default: $sectiontitle = get_string('section'); break;
                 }
-                echo ' '.$sectionnum.'</h3></td></tr>';
+
+                $sectioncell->text = $OUTPUT->heading($sectiontitle . ' ' . $sectionnum, 3);
+                $sectionrow->cells[] = $sectioncell;
+                $outlinetable->data[] = $sectionrow;
 
                 $prevsecctionnum = $sectionnum;
             }
 
             $dimmed = $cm->visible ? '' : 'class="dimmed"';
             $modulename = get_string('modulename', $cm->modname);
-            echo '<tr class="r'.$ri++.'">';
-            echo "<td class=\"cell c0 actvity\"><img src=\"" . $OUTPUT->mod_icon_url('icon', $cm->modname) . "\" class=\"icon\" alt=\"$modulename\" />";
-            echo "<a $dimmed title=\"$modulename\" href=\"$CFG->wwwroot/mod/$cm->modname/view.php?id=$cm->id\">".format_string($cm->name)."</a></td>";
-            echo "<td class=\"cell c1 numviews\">";
+
+            $reportrow = new html_table_row();
+            $activitycell = new html_table_cell();
+            $activitycell->add_class('activity');
+
+            $activityicon = html_image::make($OUTPUT->mod_icon_url('icon', $cm->modname));
+            $activityicon->add_class('icon');
+            $activityicon->alt = $modulename;
+
+            $activitylink = html_link::make("$CFG->wwwroot/mod/$cm->modname/view.php?id=$cm->id", format_string($cm->name));
+            if (!$cm->visible) {
+                $activitylink->add_class('dimmed');
+            }
+
+            $activitycell->text = $OUTPUT->image($activityicon) . $OUTPUT->link($activitylink);
+
+            $reportrow->cells[] = $activitycell;
+
+            $numviewscell = new html_table_cell();
+            $numviewscell->add_class('numviews');
+
             if (!empty($views[$cm->id]->numviews)) {
-                echo $views[$cm->id]->numviews;
+                $numviewscell->text = $views[$cm->id]->numviews;
+            } else {
+                $numviewscell->text = '-';
+            }
+
+            $reportrow->cells[] = $numviewscell;
+
+            if ($CFG->useblogassociations) {
+                $blogcell = new html_table_cell();
+                $blogcell->add_class('blog');
+                if ($blogcount = blog_get_associated_count($course->id, $cm->id)) {
+                    $blogcell->text = $OUTPUT->link(html_link::make('/blog/index.php?modid='.$cm->id, $blogcount));
-            } else {
+                } else {
-                echo '-';
+                    $blogcell->text = '-';
-            }
+                }
-            echo "</td>";
+                $reportrow->cells[] = $blogcell;
+            }
+
             if ($showlastaccess) {
-                echo "<td class=\"cell c2 lastaccess\">";
+                $lastaccesscell = new html_table_cell();
+                $lastaccesscell->add_class('lastaccess');
+
                 if (isset($views[$cm->id]->lasttime)) {
                     $timeago = format_time(time() - $views[$cm->id]->lasttime);
-                    echo userdate($views[$cm->id]->lasttime)." ($timeago)";
+                    $lastaccesscell->text = userdate($views[$cm->id]->lasttime)." ($timeago)";
                 }
-                echo "</td>";
+                $reportrow->cells[] = $lastaccesscell;
             }
-            echo '</tr>';
+            $outlinetable->data[] = $reportrow;
         }
     }
-    echo '</table>';
+    echo $OUTPUT->table($outlinetable);
 
     echo $OUTPUT->footer();
 
Index: course/reset_form.php
=========================================================
--- course/reset_form.php	(revision 1.6)
+++ course/reset_form.php	Thu Oct 15 09:39:03 WST 2009
@@ -14,6 +14,8 @@
         $mform->addElement('checkbox', 'reset_events', get_string('deleteevents', 'calendar'));
         $mform->addElement('checkbox', 'reset_logs', get_string('deletelogs'));
         $mform->addElement('checkbox', 'reset_notes', get_string('deletenotes', 'notes'));
+        $mform->addElement('checkbox', 'delete_blog_associations', get_string('deleteblogassociations', 'blog'));
+        $mform->setHelpButton('delete_blog_associations', array('deleteblogassociations', get_string('deleteblogassociations', 'blog'), 'blog'));
 
 
         $mform->addElement('header', 'rolesheader', get_string('roles'));
Index: lang/en_utf8/admin.php
=========================================================
--- lang/en_utf8/admin.php	(revision 1.306)
+++ lang/en_utf8/admin.php	Fri Oct 16 15:13:12 WST 2009
@@ -38,6 +38,33 @@
 $string['blockmultiple'] = 'Multiple';
 $string['blocksettings'] = 'Manage blocks';
 $string['bloglevel'] = 'Blog visibility';
+$string['bloglevelupgrade'] = 'Blog visibility upgrade';
+$string['bloglevelupgradebody'] = 'Hi! You are receiving this message as an administrator of $a->sitename.
+
+This site has recently been upgraded to Moodle 2.0.
+
+Blog visibility was simplified in 2.0, but your site still uses one of the old visibility types.
+
+To preserve the course-based or group-based visibility of the blog entries on your site, you need to run the following upgrade script, which will create a special "blog" type forum in each course whose enrolled users have posted blog entries, and will copy these blog entries in this special forum.
+
+Blogs will then be entirely switched off at the site level. No blog entries will be deleted in the process.
+
+You can run the script by visiting $a->fixurl.
+';
+$string['bloglevelupgradehtml'] = '<p>Hi! You are receiving this message as an administrator of $a->sitename.</p>
+
+<p>This site has recently been upgraded to Moodle 2.0.</p>
+
+<p>Blog visibility was simplified in 2.0, but your site still uses one of the old visibility types. </p>
+
+<p>To preserve the course-based or group-based visibility of the blog entries on your site, you need to run the following upgrade script, which will create a special "blog" type forum in each course whose enrolled users have posted blog entries, and will copy these blog entries in this special forum. </p>
+
+<p>Blogs will then be entirely switched off at the site level. No blog entries will be deleted in the process.</p>
+
+<p>You can run the script by visiting <a href=\"$a->fixurl\">the blog level upgrade page</a>.</p>';
+$string['bloglevelupgradeinfo'] = 'Blog visibility was simplified in 2.0, but your site still uses one of the old visibility types. To preserve the course-based or group-based visibility of the blog entries on your site, the following upgrade script will create a special "blog" type forum in each course whose enrolled users have posted blog entries, and will copy these blog entries in this special forum. Blogs will then be entirely switched off at the site level. No blog entries will be deleted in the process.';
+$string['bloglevelupgradenotice'] = 'Your site is using an old blog visibility setting, the <a href=\"bloglevelupgrade.php\">blog visibility upgrade</a> is recommended.';
+$string['bloglevelupgradeprogress'] = 'Conversion progress: $a->userscount users reviewed, $a->blogcount entries converted.';
 $string['bookmarkadded'] = 'Bookmark added.';
 $string['bookmarkalreadyexists'] = 'You have already bookmarked this page.';
 $string['bookmarkdeleted'] = 'Bookmark deleted.';
Index: lang/en_utf8/block_blog_recent.php
=========================================================
--- lang/en_utf8/block_blog_recent.php	(revision 0)
+++ lang/en_utf8/block_blog_recent.php	Thu Oct 15 11:09:32 WST 2009
@@ -0,0 +1,5 @@
+<?php
+$string['blockname'] = 'Recent blog entries';
+$string['norecentblogentries'] = 'No recent entries';
+$string['numentriestodisplay'] = 'Number of recent entries to display';
+$string['recentinterval'] = 'Interval of time considered \"recent\"';
